<template>
  <GManageTable
    :card="card"
    :i18n-base="i18nBase"
    v-bind="$attrs"
    :headers="headers"
    :items="value.respPerson"
    use-wrapper
    :optional="optional"
    :wiki-entry="wikiEntry"
    :get-new-item="getNewItem"
    @create="create"
    @edit="edit"
    @remove="remove"
    @deleteElement="$emit('delete')"
  >
    <template #form="{ item, updateAvailableElements }">
      <RespPerson
        v-model="item.value"
        :update-available-elements="updateAvailableElements"
      />
    </template>

    <template #[`item.person.name`]="{ item }">
      {{ getForCurrentLocale(item.person.name) }}
    </template>
    <template #[`item.person.eMail`]="{ item }">
      {{ item.person.eMail | _textOrDashIfUndefined }}
    </template>
    <template #[`item.location`]="{ item }">
      {{ item.location | formatLocation }}
    </template>
    <template #[`item.further`]="{ item }">
      <v-tooltip v-if="item.mainSigner && item.mainSigner.value" bottom>
        <template #activator="{ on }">
          <v-icon small v-on="on">verified_user</v-icon>
        </template>
        <span>{{ $t("dcc.administrativeData.respPersons.mainSigner") }}</span>
      </v-tooltip>
      <v-tooltip
        v-if="item.cryptElectronicSeal && item.cryptElectronicSeal.value"
        bottom
      >
        <template #activator="{ on }">
          <v-icon small v-on="on">fingerprint</v-icon>
        </template>
        <span>{{
          $t("dcc.administrativeData.respPersons.cryptElectronicSeal")
        }}</span>
      </v-tooltip>
      <v-tooltip
        v-if="
          item.cryptElectronicSignature && item.cryptElectronicSignature.value
        "
        bottom
      >
        <template #activator="{ on }">
          <v-icon small v-on="on"> vpn_key </v-icon>
        </template>
        <span>{{
          $t("dcc.administrativeData.respPersons.cryptElectronicSignature")
        }}</span>
      </v-tooltip>
    </template>
  </GManageTable>
</template>

<script>
import { RespPersonType } from "@d-ptb/dcc-js";
import { validatableMixin } from "../../Mixins/validatableMixin";
import { removeFromArray } from "~/assets/util/general";
import GManageTable from "~/components/App/Common/ManagementTable/GManageTable";
import { localizationMixin } from "~/components/Mixins/localizationMixin";
import RespPerson from "~/components/DCC/AdministrativeData/RespPerson.vue";

export default {
  name: "RespPersonList",
  components: {
    RespPerson,
    GManageTable,
  },
  mixins: [validatableMixin, localizationMixin],
  props: {
    value: Object,
    i18nBase: {
      type: String,
      default: "dcc.administrativeData.respPersons",
    },
    card: {
      type: Boolean,
      default: true,
    },
    optional: {
      type: Boolean,
      default: false,
    },
    wikiEntry: {
      type: String,
      default: "respPerson",
    },
  },
  data() {
    return {
      headers: [
        {
          text: this.$t("dcc.common.attributes.refType"),
          value: "_attr.refType",
        },
        {
          text: this.$t("dcc.administrativeData.respPersons.person"),
          value: "person.name",
          sortable: false,
        },
        {
          text: this.$t("dcc.common.contactType.email"),
          value: "person.eMail",
        },
        {
          text: this.$t("dcc.common.locationType.title"),
          value: "location",
          sortable: false,
        },
        {
          text: this.$t("dcc.administrativeData.respPersons.further"),
          value: "further",
          sortable: false,
        },
      ],
    };
  },
  computed: {
    customRules() {
      return [
        () =>
          this.value.respPerson.length > 0 ||
          this.$t("dcc.administrativeData.respPersons.empty"),
      ];
    },
  },
  watch: {
    "value.respPerson"() {
      this.validate();
    },
  },
  methods: {
    remove(item) {
      removeFromArray(this.value.respPerson, item);
    },
    create(item) {
      this.value.respPerson.push(new RespPersonType(item));
    },
    edit(item, index) {
      this.$set(this.value.respPerson, index, undefined);
      this.$set(this.value.respPerson, index, new RespPersonType(item));
    },
    getNewItem() {
      return new RespPersonType();
    },
  },
};
</script>
